import 'dart:core';

extension IterableExtension<E> on Iterable<E> {
  List<T> mapWhere<T>(T f(E e), bool test(E e)) {
    List<T> result = [];
    forEach((element) {
      if(test(element)) result.add(f(element));
    });
    return result;
  }
}