import 'package:http/http.dart' as http;
import 'dart:io';
import 'dart:async';

class ConnectionUtils {

  ///
  /// [timeout] in milliseconds
  ///
  static Future<bool> isResponseSuccessful(String url, {int? timeout}) async {
    try {
      final future = http.head(Uri.parse(url));
      final response = await (timeout == null
          ? future
          : future.timeout(Duration(milliseconds: timeout)));
      return response.statusCode >= 200 || response.statusCode < 300;
    } catch (e) {
      print(e);
    }
    return false;
  }

  ///
  /// [timeout] in milliseconds
  ///
  static Future<bool> isResponseOnline(String url, {int? timeout}) async {
    final future = http.head(Uri.parse(url));
    final response = await (timeout == null
        ? future
        : future.timeout(Duration(milliseconds: timeout)));
    switch (response.statusCode) {
      case HttpStatus.notFound:
      case HttpStatus.requestTimeout:
      case HttpStatus.gatewayTimeout:
      case HttpStatus.networkConnectTimeoutError:
        return false;
    }
    return true;
  }
}
